From 2b6acc854a6a0bfe3ae298b2476df86162fe8bb3 Mon Sep 17 00:00:00 2001
From: Devyani Kota <divs.passion.18@gmail.com>
Date: Nov 05 2015 19:23:11 +0000
Subject: [PATCH 232/1001] Added manage_subscriptions() to hyperlink subscriptions and memberships


---

diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
index 36e830d..d32e47b 100644
--- a/hubs/widgets/subscriptions.py
+++ b/hubs/widgets/subscriptions.py
@@ -8,21 +8,20 @@ import hubs.models
 
 from fedmsg.meta.base import BaseConglomerator as BC
 
+import flask
 import jinja2
 
 chrome = panel('Hubs', key='associations')
 template = jinja2.Template("""
 {% if associations %}
     {% if memberships %}
-        <p><strong>Belongs to: </strong>{{memberships_text}}</p>
+        <p><strong>Belongs to: </strong>
+        {{memberships_text}}</p>
     {% endif %}
     <hr/>
     {% if subscriptions %}
         <p><strong>Subscribes to:</strong>
-        {% for subscription in subscriptions %}
-        <a href="{{ url_for('hub', name=subscription)}}">
-        {{subscription}}</a>
-        {% endfor %}</p>
+        {{subscriptions_text}}</p>
     {% endif %}
 {% endif %}
 """)
@@ -37,16 +36,29 @@ def data(session, widget, username):
     ownerships = [u.name for u in user.ownerships]
     memberships = [u.name for u in user.memberships]
     subscriptions = [u.name for u in user.subscriptions]
+    subs = subscriptions
+    mems = memberships
+    subscriptions_list = manage_subscriptions(subs)
+    memberships_list = manage_subscriptions(mems)
     return dict(
         associations=memberships + ownerships,
         ownerships=ownerships,
         memberships=memberships,
         subscriptions=subscriptions,
         ownerships_text=BC.list_to_series(ownerships),
-        memberships_text=BC.list_to_series(memberships),
-        subscriptions_text=BC.list_to_series(subscriptions),
+        memberships_text=BC.list_to_series(memberships_list),
+        subscriptions_text=BC.list_to_series(subscriptions_list),
     )
 
 
+# function hyperlinks
+def manage_subscriptions(s):
+    for j, i in enumerate(s[0:3]):
+        link = '<a href="{link}">{item}</a>'.format(link=flask.url_for(
+            'hub', name=i), item=i)
+        s[j] = link
+    return s
+
+
 def should_invalidate(message, session, widget):
     raise NotImplementedError()

